'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.describe = exports.context = undefined;

var _ava = require('ava');

var _ava2 = _interopRequireDefault(_ava);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint ava/test-ended:0 */

var buildMsg = function buildMsg(first, second) {
  return [first, second].filter(function (a) {
    return a;
  }).join(' - ');
};

var turnEndlessArrayStructureIntoArrayOfTestObjects = function turnEndlessArrayStructureIntoArrayOfTestObjects(endlessArrayStructure) {
  var arrayOfObjects = [];
  endlessArrayStructure.forEach(function (el) {
    if (typeof el[0] === 'string') {
      arrayOfObjects.push({ msg: el[0], test: el[1], cb: el[2] === 'cb' });
    } else {
      el.forEach(function (obj) {
        arrayOfObjects.push(obj);
      });
    }
  });
  return _lodash2.default.flattenDeep(arrayOfObjects);
};

var context = exports.context = function context(msg, arrayOfMessagesAndExamples) {
  return turnEndlessArrayStructureIntoArrayOfTestObjects(arrayOfMessagesAndExamples).map(function (obj) {
    return Object.assign({}, obj, { msg: buildMsg(msg, obj.msg) });
  });
};

var describe = exports.describe = function describe(describeMsg, exampleArray) {
  return context(describeMsg, exampleArray).forEach(function (ex) {
    if (ex.cb) {
      _ava2.default.cb(ex.msg, ex.test);
    } else {
      (0, _ava2.default)(ex.msg, ex.test);
    }
  });
};

exports.default = describe;